package com.ruoyi.web.controller.topology;

import com.alibaba.fastjson.JSONObject;
import com.ruoyi.common.constant.Constants;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.common.utils.sign.RsaUtils;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.StringRedisTemplate;
import org.springframework.web.bind.annotation.*;

/**
 * 组态公共调用方法
 * @author jianglw
 * @version 1.0
 * @date 2021/4/7 10:34
 */
@RestController
@RequestMapping("/params")
@Slf4j
public class ParamsController {
    @Autowired
    private StringRedisTemplate stringRedisTemplate;
    /**
     *
     * @param id
     * @param tag
     * @param fun
     * @return
     */
    @GetMapping("/show")
    public AjaxResult show(@RequestParam(value = "id") String id,
                                @RequestParam(value = "tag") String tag,
                                @RequestParam(value = "fun") String fun){
        Integer ids;
        try {
            ids= Integer.parseInt( RsaUtils.encryptByPrivateKey( id ) );
        } catch (Exception e) {
            log.error(e.getLocalizedMessage());
            e.printStackTrace();
            return AjaxResult.error("id解析失败");
        }
        String value=stringRedisTemplate.opsForValue().get( Constants.TOPOLOGY_DATA+ids );
        JSONObject jsonObject=JSONObject.parseObject( value );
        JSONObject topologyHandle =jsonObject.getJSONObject( "topologyHandle" );
        Integer dataAcquisition =topologyHandle.getInteger( "dataAcquisitionMode" );
        return AjaxResult.success();
    }

}
