package com.ruoyi.common.handlefile;

import org.springframework.web.multipart.MultipartFile;

import java.io.IOException;

/**
 * 处理文件接口
 * @author jianglw
 * @version 1.0
 * @date 2021/1/28 18:48
 */
public interface HandleFile {
    /**
     * 读取文件
     * @param file
     */
    public HandleFile readFile(MultipartFile file) throws IOException;

    /**
     * 加密文件
     * @param file
     */
    public HandleFile encryptionFile() throws Exception;

    /**
     * 解析文件
     * @param file
     */
    public HandleFile decryptFile()throws Exception;

    /**
     * 生成文件
     * @param fileName
     * @param userName
     * @param createdPath
     * @throws IOException
     */
    public void createFile(String fileName,String userName,String createdPath) throws IOException;

}
