package com.ruoyi.common.topology.handletype;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.ruoyi.common.topology.change.AssembleData;
import com.ruoyi.common.topology.change.EchartsSet;
import com.ruoyi.common.topology.change.Handle;
import com.ruoyi.common.utils.StringUtils;
import lombok.extern.slf4j.Slf4j;

import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

/**
 * 组装echarts数据
 * @author jianglw
 * @version 1.0
 * @date 2021/6/1 17:26
 */
@Slf4j
public class DataParam implements NodeLineParamsInt{

    @Override
    public void getDataToParams(Handle handle, Map<String, Object> map, Map<String, Object> map1, String echarts) {

        //判断是否为自定义图表
        if(!handle.getCustomChart()){
            map1.put( handle.getType(), AssembleData.getData( handle,map));
        }else{
            if(StringUtils.isNotBlank( echarts )){
                JSONObject jsonObject=JSONObject.parseObject( echarts );
                JSONObject jsonObject1=JSONObject.parseObject( echarts ).getJSONObject( "option" );
                jsonObject1.getJSONObject( "title" ).put( "text",handle.getTitle() );
                List<String> list=new LinkedList<>();
                List<String> xList=new LinkedList<>();
                List<Map<String,Object>> seriesList=new LinkedList<>();
                Map<String,Object> map2=null;
                for(EchartsSet echartsSet:handle.getEchartsArray()){
                    if(echartsSet.getAxis().equals( "yAxis" )){
                        map2=new HashMap<>();
                        map2.put( "name",echartsSet.getName() );
                        map2.put( "type" ,echartsSet.getSeriesType());
                        map2.put( "data",map.get( echartsSet.getPoint() )+"" );
                        seriesList.add( map2 );
                        list.add( echartsSet.getName() );
                    }
                    if(echartsSet.getAxis().equals( "xAxis" )){
                        xList.add( map.get( echartsSet.getPoint() )+""  );
                    }
                }
                JSONArray jsonArray=jsonObject1.getJSONArray( "series" );
                if(jsonArray.size()==seriesList.size()){
                    for(int i=0;i<jsonArray.size();i++){
                        for(Map<String,Object> m:seriesList){
                            if(jsonArray.getJSONObject( i ).getString( "name" ).equals( m.get( "name" ) )){
                                JSONObject jsonObject2=jsonArray.getJSONObject( i );
                                jsonObject2=JSONObject.parseObject( JSON.toJSONString( m ) );
                            }
                        }
                    }
                }else{
                    jsonArray=JSONArray.parseArray( JSON.toJSONString( seriesList ) );
                }
                jsonObject1.getJSONObject( "xAxis" ).put( "data",xList );
                jsonObject1.getJSONObject( "legend" ).put( "data",list );
                map1.put( "data", jsonObject.toJSONString());
            }else{
                log.debug( "未获取到组态中的图表信息");
            }
        }
        //echarts 在canvas上刷新使用
        map1.put( "elementRendered", false);

    }
}
