package com.ruoyi.framework.config;

import com.influxdb.client.InfluxDBClient;
import com.influxdb.client.InfluxDBClientFactory;
import com.influxdb.client.InfluxDBClientOptions;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.boot.autoconfigure.condition.ConditionalOnProperty;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

/**
 * @author jianglw
 * @version 1.0
 * @date 2021/4/27 17:22
 */
@Configuration
public class InfluxDBConfig {
    @Value( "${influxdb.url}" )
    private String url;

    @Value( "${influxdb.token}" )
    private String token;
    @Value( "${influxdb.bucket}" )
    private String bucket;
    @Value( "${influxdb.org}" )
    private String org;

    @Bean(name = "getInfluxDB")
    @ConditionalOnProperty(prefix = "influxdb", name = "enabled", havingValue = "true")
    public InfluxDBClient getInfluxDB(){
        return InfluxDBClientFactory.create(url, token.toCharArray(),org);
    }

    @Bean(name = "getBucket")
    @ConditionalOnProperty(prefix = "influxdb", name = "enabled", havingValue = "true")
    public String getBucket(){
        return this.bucket;
    }
}
