package com.ruoyi.framework.mail.service.impl;

import com.ruoyi.framework.mail.service.IMailService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.core.io.FileSystemResource;
import org.springframework.mail.javamail.JavaMailSender;
import org.springframework.mail.javamail.MimeMessageHelper;
import org.springframework.stereotype.Service;

import javax.mail.MessagingException;
import javax.mail.internet.MimeMessage;
import java.io.File;

/**
 * 发送邮件实现类
 * @author jianglw
 * @version 1.0
 * @date 2021/1/29 18:39
 */
@Service
public class IMailServiceImpl implements IMailService {
    /**
     * Spring Boot 提供了一个发送邮件的简单抽象，使用的是下面这个接口，这里直接注入即可使用
     */
    @Autowired
    private JavaMailSender mailSender;
    /**
     * 配置文件中邮箱
     */

    @Override
    public void sendSimpleMail(String to, String subject, String content) {

    }

    @Override
    public void sendHtmlMail(String to, String subject, String content) {

    }

    @Override
    public void sendAttachmentsMail(String from,String to, String subject, String content ,FileSystemResource file) {
        MimeMessage message = mailSender.createMimeMessage();
        try {
            MimeMessageHelper helper = new MimeMessageHelper(message, true);
            helper.setFrom(from);
            helper.setTo(to);
            helper.setSubject(subject);
            helper.setText(content, true);
            helper.addAttachment("配置文件.zip", file);
            mailSender.send(message);
            //日志信息
            System.out.println("邮件已经发送。");
        } catch (MessagingException e) {
            System.out.println("发送邮件时发生异常！");
        }
    }
}
