package com.ruoyi.framework.task;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.influxdb.client.InfluxDBClient;
import com.influxdb.client.WriteApi;
import com.influxdb.client.domain.FluxResponse;
import com.influxdb.client.domain.WritePrecision;
import com.influxdb.client.write.Point;
import com.influxdb.query.FluxRecord;
import com.influxdb.query.FluxTable;
import com.ruoyi.common.constant.Constants;
import com.ruoyi.common.utils.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.data.redis.core.StringRedisTemplate;
import org.springframework.stereotype.Component;

import java.text.DecimalFormat;
import java.time.Instant;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Random;

/**
 * 定时任务调度测试
 *
 * @author ruoyi
 */
@Component("ryTask")
public class RyTask {
    @Autowired
    private StringRedisTemplate stringRedisTemplate;
    @Autowired
    private InfluxDBClient influxDBClient;

    @Value( "${influxdb.bucket}" )
    private String bucket;
    @Value( "${influxdb.org}" )
    private String org;

    Random random = new Random();

    DecimalFormat decimalFormat=new DecimalFormat(".00");
    final String str = "total_power,start_power,theory,theory_1,available," +
            "a_1,a_2,a_3,a_4,a_5,a_6,a_7,Ua,Ub,Uc,Uab,Ubc,Uca,3U0," +
            "p1,p2,p3,p4,p5,p6,p7,p8,p9,p10,p11,p12,p13,p14,p15,p16,p17," +
            "p18,p19,p20,p21,p22,p23,p24,p25,p26,p27,p28,p29,p30,p31,p32," +
            "p33,p34,p35,p36,p37,p38,p39,p40,p41,p42";


    public void ryMultipleParams(String s, Boolean b, Long l, Double d, Integer i) {
        System.out.println( StringUtils.format( "执行多参方法： 字符串类型{}，布尔类型{}，长整型{}，浮点型{}，整形{}", s, b, l, d, i ) );
    }

    public void ryParams(String params) {
        Map<String,Object> map=new LinkedHashMap<>(  );
        map.put( "tag1",random.nextFloat() );
        map.put( "tag2",random.nextFloat() );
        Point point = Point
                .measurement("mem")
                .addFields( map )
                .time( Instant.now(), WritePrecision.NS);
        try (WriteApi writeApi = influxDBClient.getWriteApi()) {
            writeApi.writePoint(bucket, org, point);
        }

    }

    public void ryNoParams() {
//        JSONObject jsonObject = new JSONObject();
//
//        String[] strArr = str.split( "," );
//        for (int i = 0; i < strArr.length; i++) {
//            jsonObject.put( strArr[i], decimalFormat.format( random.nextFloat() * 100 ) );
//        }
//        stringRedisTemplate.opsForValue().set( "gf:data", jsonObject.toJSONString() );
//        System.out.println( "执行无参方法" );
        JSONObject jsonObject=JSONObject.parseObject( stringRedisTemplate.opsForValue().get( Constants.TOPOLOGY_DATA+"38" ) );
        JSONArray jsonArray=jsonObject.getJSONArray( "pens" );
        JSONObject jsonObject2=new JSONObject();
        for(int i=0;i<jsonArray.size();i++){
            JSONObject jsonObject1=jsonArray.getJSONObject( i );
            if(jsonObject1.getJSONArray( "tags" ).size()>0 ){
                jsonObject2.put( jsonObject1.getJSONArray( "tags" ).getString( 0 ),random.nextBoolean()?"1":"0" );
            }
        }
        System.out.println(jsonObject2.toJSONString());
        stringRedisTemplate.opsForValue().set( "fd:data", jsonObject2.toJSONString() );
    }
}
