package com.ruoyi.framework.topology.collect;

import com.alibaba.fastjson.JSONArray;
import com.ruoyi.common.enums.NodeLineParams;
import com.ruoyi.common.topology.change.EchartsSet;
import com.ruoyi.framework.topology.emnus.ShareDataType;
import com.ruoyi.common.topology.change.ChangeSub;
import com.ruoyi.common.topology.change.Handle;
import shareconnector.netty.ShareServerFactory;
import shareconnector.service.SendAndRequestService;

import java.util.*;

/**
 * @author jianglw
 * @version 1.0
 * @date 2021/4/9 10:34
 */
public class ShareServerType implements CollectTopologyType {
    ShareServerFactory shareServerFactory=ShareServerFactory.getInstance();
    @Override
    public Map<String,Object> getData(String param, JSONArray jsonArray) {
        String[] params=param.split( ":" );
        shareServerFactory.setIp( params[0] ).setPort( Integer.parseInt( params[1] ) );
        List<ChangeSub> list=jsonArray.toJavaList( ChangeSub.class );
        Map<String, Set<Integer>> map =new LinkedHashMap<>(  );
        Set<Integer> set=null;
        for(ChangeSub changeSub:list) {
            List<Handle> handleList = changeSub.getHandle();
            for(Handle handle:handleList){
                //获取echarts数据
                if(handle.getType().equals( NodeLineParams.DATA.type )){
                    for(EchartsSet echartsSet:handle.getEchartsArray()){
                        //echarts数据均为Float类型
                        if(map.containsKey( ShareDataType.FLOAT.name() )){
                            map.get( handle.getShareType() ).add( Integer.parseInt( echartsSet.getPoint() ) );
                        }else{
                            set=new LinkedHashSet<>(  );
                            set.add( Integer.parseInt( echartsSet.getPoint() ) );
                            map.put( ShareDataType.FLOAT.name(),set );
                        }
                    }
                //获取除echarts数据
                }else{
                    if(map.containsKey( handle.getShareType() )){
                        map.get( handle.getShareType() ).add( Integer.parseInt( handle.getPoint() ) );
                    }else{
                        set=new LinkedHashSet<>(  );
                        set.add( Integer.parseInt( handle.getPoint() ) );
                        map.put( handle.getShareType(),set );
                    }
                }

            }
        }
        Map<String,Object> map1=new LinkedHashMap<>(  );
        for(Map.Entry<String,Set<Integer>> setEntry:map.entrySet()){
            Map<Integer,Object> map2=SendAndRequestService.getInstance().getDatas(setEntry.getValue(), ShareDataType.match(setEntry.getKey())  );
            map1.put( setEntry.getKey(),map2 );
        }
        return  map1;
    }
}
