package com.ruoyi.framework.topology.emnus;

import com.ruoyi.framework.topology.collect.*;

/**
 * 获取topology
 *
 * @author jianglw
 * @version 1.0
 * @date 2021/4/9 10:31
 */
public enum CollectTopology {
    /**
     * mysql
     */
    MYSQL( 0, new MysqlType() ),
    ORACLE(1,new OracleType()),
    /**
     * redis
     */
    REDIS( 3, new RedisType() ),
    /**
     * influxdb
     */
    INFLUXDB( 2, new InfluxdbType() ),
    /**
     * shareserver
     */
    SHARESERVER( 4, new ShareServerType() );

    public int i;
    public CollectTopologyType collectTopologyType;

    CollectTopology(int i, CollectTopologyType collectTopologyType) {
        this.i = i;
        this.collectTopologyType = collectTopologyType;
    }

    //匹配
    public static CollectTopologyType match(int i) {
        CollectTopology[] values = CollectTopology.values();
        for (CollectTopology value : values) {
            if (value.i == i) {
                return value.collectTopologyType;
            }
        }
        return null;
    }
}
