package com.ruoyi.topology.service.impl;

import com.ruoyi.common.core.domain.topology.TopologyData;
import com.ruoyi.common.utils.SecurityUtils;
import com.ruoyi.topology.mapper.TopologyMapper;
import com.ruoyi.topology.service.ITopologyService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;

/**
 * @author jianglw
 * @version 1.0
 * @date 2021/3/29 15:01
 */
@Service
public class TopologyService implements ITopologyService {
    @Autowired
    private TopologyMapper topologyMapper;
    @Override
    public void saveTopologyToId(TopologyData topologyData) {
        topologyMapper.saveTopologyToId(topologyData);
    }

    @Override
    public List<TopologyData> getTopology(TopologyData topologyData) {
        if(!SecurityUtils.isAdmin( SecurityUtils.getLoginUser().getUser().getUserId() )){
            topologyData.setSwitchIt( "1" );
        }
        return topologyMapper.getTopology(topologyData);
    }

    @Override
    public TopologyData getTopologyById(Integer id) {
        return topologyMapper.getTopologyById(id);
    }

    @Override
    public void updateTopologyById(TopologyData topologyData) {
        topologyMapper.updateTopologyById(topologyData);
    }

    @Override
    public Integer deleteTopologyById(Integer id) {
        return topologyMapper.deleteTopologyById(id);
    }

    @Override
    public Map<String,Object> getData(String sql) {
        return topologyMapper.getData(sql);
    }
}
